/**
 * Theme Customizer enhancements for a better user experience.
 *
 * Contains handlers to make Theme Customizer preview reload changes asynchronously.
 */

( function( $ ) {
	// Site title and description.
	wp.customize( 'blogname', function( value ) {
		value.bind( function( to ) {
			$( 'body > header p' ).text( to );
		} );
	} );
	wp.customize( 'blogdescription', function( value ) {
		value.bind( function( to ) {
			$( 'body > header h1' ).text( to );
		} );
	} );
	wp.customize( 'background_color', function( value ) {
		value.bind( function( to ) {
			$( 'body #comments' ).css( 'background-color', to );
		} );
	} );
	wp.customize( 'header_backgroundcolor', function( value ) {
		value.bind( function( to ) {
			$( 'body > header' ).css( 'background-color', to );
			$( 'body > header h1' ).css( 'background-color', to );
			$( 'body > footer' ).css( 'background-color', to );
			$( 'body > footer' ).css( 'border-color', to );
			$( 'body > aside h2' ).css( 'background-color', to );
			$( 'body > main > article > ul > li h2' ).css( 'background-color', to );
			$( 'body > aside caption' ).css( 'background-color', to );
			$( 'body > main article h1' ).css( 'border-color', to );
			$( 'body > main article h2' ).css( 'border-color', to );
			$( 'body > main article h3' ).css( 'border-color', to );
			$( 'body > main article h4' ).css( 'border-color', to );
			$( 'body > main article h5' ).css( 'border-color', to );
			$( 'body > main article h6' ).css( 'border-color', to );
		} );
	} );
	// Header text color.
	wp.customize( 'header_textcolor', function( value ) {
		value.bind( function( to ) {
			if ( 'blank' === to ) {
				$( 'body > header p' ).css( {
					'clip': 'rect(1px, 1px, 1px, 1px)',
					'position': 'absolute'
				} );
			} else {
				$( 'body > main > article > ul > li h2, body > header, body > header h1, body > footer, body > aside h2, body > aside caption' ).css( {
					'color': to
				} );
			}
		} );
	} );
} )( jQuery );
