<?php

function graftee_breadcrumb() {
	$options = graftee_get_option();

	if ( ! empty( $options['show_breadcrumb'] ) ) {
		global $wp_query, $post, $page, $paged;

		$taxonomy_slug = get_query_var( 'taxonomy' );
		$cpt = get_query_var( 'post_type' );

		if ( !is_front_page() && !is_home() && !is_admin() ) : ?>
			<ol itemscope itemtype="http://schema.org/BreadcrumbList">
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo esc_url( home_url( '/' ) ); ?>"><?php bloginfo( 'name' ); ?></a></li>

			<?php if ( $taxonomy_slug && is_tax( $taxonomy_slug ) ) :
				$query_tax = get_queried_object();
				$query_tax_parent = $query_tax -> parent;
				$post_types = get_taxonomy( $taxonomy_slug ) -> object_type;
				$cpt = $post_types[0];
			?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_post_type_archive_link( $cpt ); ?>"><?php echo esc_html( get_post_type_object( $cpt ) -> label ); ?></a></li>
			<?php if ( ! empty( $query_tax_parent ) ) :
				$ancestors = array_reverse( get_ancestors( $query_tax -> term_id, $query_tax -> taxonomy ) );
				foreach( $ancestors as $ancestor ) : ?>
					<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_term_link( $ancestor, $query_tax -> taxonomy ); ?>"><?php echo esc_html( get_term( $ancestor, $query_tax -> taxonomy ) -> name ); ?></a></li>
				<?php endforeach; endif; ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php echo esc_html( $query_tax -> name ); ?>

			<?php elseif ( $cpt && is_singular( $cpt ) ) :
				$cpt_taxes = get_object_taxonomies( $cpt );

				if ( ! empty( $cpt_taxes ) ) :
					$taxonomy_name = $cpt_taxes[0];
					?>
					<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_post_type_archive_link( $cpt ); ?>"><?php echo esc_html( get_post_type_object( $cpt ) -> label ); ?></a></li>
					<?php
					$taxes = get_the_terms( $post -> ID, $taxonomy_name );
					$count = 0;

					if ( ! empty( $taxes ) ) {
						foreach( $taxes as $tax ) {
							$children = get_term_children( $tax -> term_id, $taxonomy_name ); 

							if ( $children ) {
								if ( $count < count( $children ) ) {
									$count = count( $children );
									$lot_children = $children;
									foreach( $lot_children as $child ) {
										if( is_object_in_term( $post -> ID, $taxonomy_name ) ) {
											$child_tax = get_term( $child, $taxonomy_name );
										}
									}
								}
							} else {
								$child_tax = $tax;
							}
						}
					}

					if( ! empty( $child_tax -> parent ) ) :
						$ancestors = array_reverse( get_ancestors( $child_tax -> term_id, $taxonomy_name ) );

						foreach( $ancestors as $ancestor ) : ?>
							<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_term_link( $ancestor, $taxonomy_name ); ?>"><?php echo esc_html( get_term( $ancestor, $taxonomy_name ) -> name ); ?></a></li>
						<?php endforeach; ?>

						<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_term_link( $child_tax, $taxonomy_name ); ?>"><?php echo esc_html( $child_tax -> name ); ?></a></li>
					<?php endif; ?>
				<?php endif; ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php the_title_attribute(); ?>

			<?php elseif ( is_page() ) : ?>
			<?php $ancestors = get_post_ancestors( $post -> ID ); ?>
			<?php foreach ( array_reverse( $ancestors ) as $ancestor ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_page_link( $ancestor ); ?>"><?php echo get_the_title( $ancestor ); ?></a></li>
			<?php endforeach; ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php the_title_attribute(); ?>

			<?php elseif ( is_search() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php printf( __( 'Search Results of " %s "', 'graftee' ), get_search_query() ); ?>&nbsp;(&nbsp;<?php printf( __( '%d posts', 'graftee' ), esc_html( $wp_query -> found_posts ) ); ?>)

			<?php elseif ( is_404() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php _e( '404 Not found', 'graftee' ); ?>

			<?php elseif ( is_attachment() ) : ?>
			<?php if ( $post -> post_parent != 0 ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_permalink( $post -> post_parent ); ?>"><?php echo get_the_title( $post -> post_parent ); ?></a></li>
			<?php endif; ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php the_title_attribute(); ?>

			<?php elseif ( is_single() ) : ?>
			<?php
			$cat = get_the_category();
			if ( ! empty( $cat ) && count( $cat ) > 0 ) {
				$cat = $cat[0];

				$breadcrumbs = '<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">'.get_category_parents( $cat->term_id, true, '</li><li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">' ).'</li>';
				$breadcrumbs = str_replace( '<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"></li>', '', $breadcrumbs );
				$breadcrumbs = str_replace( 'href=', 'itemprop="item url" href=', $breadcrumbs );
				echo $breadcrumbs;
			} ?>
			<?php $title_attribute = the_title_attribute( array( 'echo' => false ) ); ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
			<?php if ( trim( $title_attribute ) != '' ): ?>
				<?php echo $title_attribute; ?>
			<?php else: ?>
				<?php _e( 'This article', 'graftee' ); ?>
			<?php endif; ?>

			<?php elseif ( is_year() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php the_time( __( 'Y', 'graftee' ) ); ?>

			<?php elseif ( is_month() || is_day() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_year_link( get_the_time( 'Y' ) ); ?>"><?php the_time( __( 'Y', 'graftee' ) ); ?></a></li>

			<?php if ( is_month() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php the_time( __( 'F', 'graftee' ) ); ?>

			<?php elseif ( is_day() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><a itemprop="item url" href="<?php echo get_year_link( get_the_time( 'm' ) ); ?>"><?php the_time( __( 'F', 'graftee' ) ); ?></a></li>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php the_time( __( 'j', 'graftee' ) ); ?>
			<?php endif; ?>

			<?php elseif ( is_category() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php single_cat_title(); ?>

			<?php elseif ( is_tag() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php single_cat_title(); ?>

			<?php elseif ( is_author() ) : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php
				if ( get_the_author_meta( 'display_name' ) ) {
					the_author_meta( 'display_name', $post -> post_author );
				} else {
					_e( 'Nothing Found', 'graftee' );
				} ?>
			<?php else : ?>
			<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem"><?php wp_title( '' ); ?>

			<?php endif;
			if ( $paged >= 2 || $page >= 2 ) {
				$page_num = sprintf( __( 'Page %d', 'graftee' ), max( $paged, $page ) );
				echo ' '.$page_num;
			} ?></li>
		</ol>
	<?php endif;
	}
}

/**
 * usage example
 *
 * <?php $options = graftee_get_option(); ?>
 *
 * <?php if ( ! empty( $options['show_breadcrumb'] ) ) : ?>
 * <div>checked show_breadcrumb</div>
 * <?php endif; ?>
 *
 */

/**
 * ------------------------------------------------------------
 * 1.0 - Register the theme options setting page,
 *       to the "appearance" in admin page
 * ------------------------------------------------------------
 */

add_action( 'admin_menu', function() {
	$options_title = sprintf( __( '%s Settings', 'graftee' ), esc_attr( wp_get_theme() ) );
	$page_hook = add_theme_page( $options_title, $options_title, 'edit_theme_options', 'theme_options', 'graftee_theme_options_do_page' );
} );

/**
 * ------------------------------------------------------------
 * 1.1 - Delete the value of this theme options
 *       after changing the theme
 * ------------------------------------------------------------
 */

add_action( 'switch_theme', function() {
	delete_option( 'graftee_theme_options' );
} );

/**
 * ------------------------------------------------------------
 * 2.0 - To register the setting of theme options
 * ------------------------------------------------------------
 */

add_action( 'admin_init', function() {
	register_setting( 'graftee_options', 'graftee_theme_options', 'graftee_theme_options_validate' );
} );

/**
 * ------------------------------------------------------------
 * 3.0 - Create an array of theme options
 *       default options
 * ------------------------------------------------------------
 */

function graftee_theme_default_options() {
	$theme_default_options = array(
		'show_breadcrumb' => 0,
	);

	return $theme_default_options;
}

/**
 * ------------------------------------------------------------
 * 4.0 - Get the value of theme options 
 * ------------------------------------------------------------
 */

function graftee_get_option() {
	return get_option( 'graftee_theme_options', graftee_theme_default_options() );
}

/**
 * ------------------------------------------------------------
 * 5.0 - Creating a theme options page
 * ------------------------------------------------------------
 */

function graftee_theme_options_do_page() {
	if ( ! isset( $_REQUEST['settings-updated'] ) )
		$_REQUEST['settings-updated'] = false;

	$settings_options = array(
		'show_breadcrumb' => array(
			'id'   => 'show_breadcrumb',
			'text' => __( 'Show breadcrumbs', 'graftee' ),
		),
	);

	?>
	<form method="post" action="options.php" enctype="multipart/form-data">
		<h2><?php echo sprintf( __( '%s Settings', 'graftee' ), esc_attr( wp_get_theme() ) ); ?></h2>

		<?php if ( false !== $_REQUEST['settings-updated'] ) : ?>
		<div class="updated fade"><p><strong><?php _e( 'Settings saved.', 'graftee' ); ?></strong></p></div>
		<?php endif; ?>

		<?php
			settings_fields( 'graftee_options' );
			$options = graftee_get_option();
		?>

		<dl>
			<dt><?php echo __( 'Display settings for each item', 'graftee' ) ?></dt>
			<dd>
				<ul>
					<?php
					if ( is_array( $settings_options ) ) :
						foreach ( $settings_options as $option ) :
							$option_id = $option['id'];
					?>
						<li>
							<label>
								<input name="graftee_theme_options[<?php echo $option_id; ?>]" type="checkbox" value="1" <?php if ( ! empty( $options[$option_id] ) ) checked( $options[$option_id], 1 ); ?> />
								<?php echo esc_attr( $option['text'] ); ?>
							</label>
						</li>
					<?php endforeach; endif; ?>
				</ul>
			</dd>
		</dl>
		<ul id="submit-button">
			<li style="display:inline-block;margin:0 .5em;"><?php submit_button( __( 'Save Changes', 'graftee' ), 'primary', 'save', false ); ?></li>
			<li style="display:inline-block;margin:0 .5em;"><?php submit_button( __( 'Reset Defaults', 'graftee' ), 'secondary', 'reset', false ); ?></li>
		</ul>
	</form>
<?php
}

/**
 * ------------------------------------------------------------
 * 6.0 - sanitize and validate
 *       By clicking the "Save" button,
 *       to sanitize and validate input. Accepts an array, return a sanitized array.
 *       By clicking the "Reset" button,
 *       to return to the default settings array.
 * ------------------------------------------------------------
 */

function graftee_theme_options_validate( $input ) {
	if ( isset( $_POST['reset'] ) ) {
		$input = graftee_theme_default_options();
	} else {
		if ( ! isset( $input['show_breadcrumb'] ) )
			$input['show_breadcrumb'] = null;
		$input['show_breadcrumb'] = ( $input['show_breadcrumb'] == 1 ? 1 : 0 );
	}
	return $input;
}
